/* $Header: /home/kig/work/convert/src/RCS/debuglog.h,v 1.1 1996/10/20 19:37:31 kig Exp kig $ */
/******************************************************************************
 *
 * FILENAME:	debuglog.h
 * MODULE:		convert
 *
 ******************************************************************************
 */

#ifndef _DEBUG_
#define _DEBUG_

/*
 * Debugging macros.
 * Example usage:
 *
 *		debuglog_open("log");
 * 		debuglog((L_TRC, funcname, "value = %d\n", i));
 * 		debuglog_close();
 *
 * Note the double brackets are required for the call
 * to debuglog, but not the other two routines.
 *
 */

#ifdef DEBUG

#define debuglog(x)		_debuglog x

#else

#define debuglog(x)

#endif /* DEBUG */


/* Message severity levels */

typedef enum debug_level
{
	L_FTL	= 0,	/* fatal */
	L_SVR	= 1,	/* severe */
	L_ERR	= 2,	/* error */
	L_WRN	= 3,	/* warning */
	L_INF	= 4,	/* info */
	L_TRC	= 5,	/* trace */
	L_DTL	= 6		/* detailed trace */
} debug_level;


/* prototypes */

int
debuglog_open
(
char	*filename
);

void
debuglog_level_set
(
int threshold
);

void
_debuglog
(
debug_level	severity,
const char	*func,
const char	*format,
...
);

int
debuglog_close
(
void
);

#endif /* _DEBUG_ */

