/* $Header: /home/kig/work/convert/src/RCS/main.h,v 1.1 1996/10/20 19:37:31 kig Exp kig $ */

/*******************************************************************************
*
*  FILE
*	main.h
*
*  REMARKS
*	vi: set tabsize=4
*
*  AUTHOR
*	Konstantin Gredeskoul <kig@cyber.com.au>
*
*******************************************************************************/

#ifndef	_MAIN_H_
#define	_MAIN_H_

/*******************************************************************************
 * defines
 ******************************************************************************/

#define		KILOBYTE			1024

#define 	FILE_NAME_SIZE		KILOBYTE
#define		CODE_ARRAY_SIZE		256
#define		LINE_SIZE			KILOBYTE

#define 	CHAR_CMD			'/'
#define		CHAR_COMMENT		'#'

#define 	MODE_ASCII_CODES	10
#define 	MODE_HEX_CODES		15	
#define		MODE_CHAR			20

#define		CMD_ASCII_CODES		"/ASC"
#define		CMD_HEX_CODES		"/HEX"
#define		CMD_CHAR			"/CHR"

#define		CMD_LEN				4

#define		PERCENT_BLOCK		512

#define		ENV_CODE_FILE_PATH	"CODE_FILE_PATH"
#define		DFL_CODE_FILE_PATH	"/usr/lib/convert"


/*******************************************************************************
 * type definitions
 ******************************************************************************/

typedef struct config_data {
	char	logfile[FILE_NAME_SIZE];
	int		loglevel;
	int		reverse_mode;
	char	codefile[FILE_NAME_SIZE];
	FILE	*fp_codefile;
	char	outfile[FILE_NAME_SIZE];
	FILE	*fp_outfile;
	char	infile[FILE_NAME_SIZE];
	FILE	*fp_infile;	
	char	sepchar;
} CONFIG_DATA;

typedef struct code_data {
	unsigned char	left[CODE_ARRAY_SIZE];
	unsigned char	right[CODE_ARRAY_SIZE];
	int				len;
} CODE_DATA;


/*******************************************************************************
 * globals
 ******************************************************************************/
static char prginfo[] = 
	"\n"
	"Convert 3.0d\n"
	"(c) 1996 Konstantin Gredeskoul <kig@cyber.com.au>\n\n";


/******************************************************************************
 * function prototypes
 ******************************************************************************/
void usage(
	void
	);

void load_codes(
	FILE *fp_codefile, 
	CODE_DATA *codes
	);

void convert(
	FILE *fp_infile,            /* input file pointer */
	FILE *fp_outfile,           /* output file pointer */
	CODE_DATA *codes,           /* pointer to codes structure */
	int reverse_mode,           /* boolean var, use reverse if this is TRUE */
	char sepchar				/* exclude variable */
	);

void check_codes(
	CODE_DATA *codes
	);

int translit_from_cyr(
	FILE *fp_infile,            /* input file pointer */
	FILE *fp_outfile,           /* output file pointer */
	char sepchar                /* exclude character */
	);

int translit_to_cyr(
	FILE *fp_infile,            /* input file pointer */
	FILE *fp_outfile,           /* output file pointer */
	char sepchar                /* exclude character */
	);

#endif /* _MAIN_H_ */

